/*---------------------------------------------------------------------------------

	Simple demonstration of sprites using textured quads

---------------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gcmodplay.h> 
#include <ogcsys.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include <time.h>

#include <gccore.h>
#include <fat.h>
#include <vector>

#include <wiiuse/wpad.h>

#include "sidestep.h"
#include "deus_bin.h"
#include "gfxUtils.h"


// Sound
#include "giz_mod.h"
#define SEQ_LENGTH 15
static MODPlay play;

extern char mydol[];

extern "C" {
#include "sudoku.h"
}

#include "tiles_bin.h"



typedef struct SudoCell
{
	s16 value;
	unsigned int state;
} SudoGrid[9][9];

// GIVEN
#define GIVEN		(1<<0)
#define INCORRECT	(1<<1)
#define UNCERTAIN	(1<<2)

SudoGrid curGrid;
int curX = 0;
int curY = 0;

#define THREADSTACK 512*1024	/*** Default 8k stack space ***/
//lwpq_t ThreadOneQ;
u8 threadonestack[THREADSTACK];

struct sudoku_info sudoku;

static void * threadone (void *arg)
{
	srand(time(NULL));
//  LWP_InitQueue (&ThreadOneQ);
	sud_struct_zero(&sudoku);
	fill(&sudoku);
	//~ display_grid(&sudoku);
//printf("thin\n");
	thin(&sudoku);
//	display_grid(&sudoku);
//	sleep(1);
  return NULL;
}

void drawSudoGrid(SudoGrid grid);
void drawSudoCursor(int x, int y);
void sudoCheck(SudoGrid grid);
void Splashscreen();

void Splashscreen()
{
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
printf ("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
usleep(2000000);
	}
	
void resetGame()
{
	lwp_t ThreadOneT;
	memcpy(threadonestack+THREADSTACK-10, "canary", 6);
	/*** Create Thread ***/
	LWP_CreateThread (&ThreadOneT, threadone, NULL, threadonestack, THREADSTACK, 128);
	int y;
	if(memcmp(threadonestack+THREADSTACK-10, "canary", 6))
	{
		for(y=0;y<9;++y)
		{
			int x;
			for(x=0;x<9;++x)
			sudoku.grid[y][x]=9;
		}	
	}

	for(y=0;y<9;++y)
	{
		int x;
		for(x=0;x<9;++x)
		{
			curGrid[y][x].value = sudoku.grid[y][x];
			curGrid[y][x].state = sudoku.grid[y][x]==0?0:GIVEN;
		}
	}
}

//---------------------------------------------------------------------------------
int main( int argc, char **argv ){
//---------------------------------------------------------------------------------
	
	VideoInit();

	WPAD_Init();

	// Initialise the audio
	AUDIO_Init(NULL);
	MODPlay_Init(&play);

    DOLtoARAM( mydol );
	
	GraphicsInit();

	const png_byte* testPtr = reinterpret_cast<png_byte const*>(tiles_bin);
	loadPngTiles( testPtr , 4, 4);

	// initialize the wii SD card fat interface.
	fatInitDefault();
	fatSetDefaultInterface(PI_INTERNAL_SD);
	// now I can fopen, etc

	char savePath[50];
	getcwd(savePath, 50);
	strcat(savePath, "/save.bin");

	FILE* saveFile = fopen(savePath, "rb");
	if(saveFile)
	{
		char buffer[81];
		fread(buffer, 1, 81, saveFile);
		fclose(saveFile);
		saveFile = NULL;		
		int y;
		int i = 0;
		for(y=0;y<9;++y)
		{
			int x;
			for(x=0;x<9;++x)
			{
				curGrid[y][x].value = buffer[i]&0x3F;
				curGrid[y][x].state = buffer[i]&0x80?GIVEN:0;
				curGrid[y][x].state|= buffer[i]&0x40?UNCERTAIN:0;
				++i;
			}
		}
	}
	else
	{
		resetGame();
	}

	while(1) {

		WPAD_ScanPads();
//		WPAD_IR(0, &ir);
		u32 btns = WPAD_ButtonsDown(0);

		if (btns & WPAD_BUTTON_HOME)
		{
			VIDEO_SetBlack(TRUE);
//			WPAD_Shutdown();
			exit(0);
		}
		if(btns & WPAD_BUTTON_UP)
		{
			if(--curX==-1) curX=8;
		}
		if(btns & WPAD_BUTTON_DOWN)
		{
			if(++curX==9) curX=0;
		}
		if(btns & WPAD_BUTTON_LEFT)
		{
			if(++curY==9) curY=0;
		}
		if(btns & WPAD_BUTTON_RIGHT)
		{
			if(--curY==-1) curY=8;
		}
		if(btns & WPAD_BUTTON_1)
		{
			MODPlay_Stop(&play);
			MODPlay_SetMOD(&play, giz_mod);
			MODPlay_Start(&play);
     	    usleep(400000);
			MODPlay_Stop(&play);
			if( !(curGrid[curY][curX].state&GIVEN) && (--curGrid[curY][curX].value==-1) ) curGrid[curY][curX].value=9;
		}
		if(btns & WPAD_BUTTON_2)
		{
			MODPlay_Stop(&play);
			MODPlay_SetMOD(&play, giz_mod);
			MODPlay_Start(&play);
			usleep(400000);
			MODPlay_Stop(&play);
			if( !(curGrid[curY][curX].state&GIVEN) && (++curGrid[curY][curX].value==10) ) curGrid[curY][curX].value=0;
		}
		if(btns & WPAD_BUTTON_PLUS)
		{
			resetGame();
		}
		if(btns & WPAD_BUTTON_MINUS)
		{
			FILE* saveFile = fopen(savePath, "wb");
			if(saveFile)
			{
				char buffer[81];
				int y;
				int i = 0;
				for(y=0;y<9;++y)
				{
					int x;
					for(x=0;x<9;++x)
					{
						buffer[i] = curGrid[y][x].value;
						buffer[i]|= curGrid[y][x].state&GIVEN?		0x80:0;
						buffer[i]|= curGrid[y][x].state&UNCERTAIN?	0x40:0;
						++i;
					}
				}
				fwrite(buffer, 1, 81, saveFile);
				fclose(saveFile);
				saveFile = NULL;		
			}
		}
		if(btns & WPAD_BUTTON_A)
		{
			curGrid[curY][curX].state ^= UNCERTAIN;
		}
				

		sudoCheck(curGrid);
		drawSudoGrid(curGrid);
		drawSudoCursor(curX,curY);

		renderToFrameBuffer(getSpareFrameBuffer());
		swapFrameBuffers();
		waitVSync();
	}
	return 0;
}


void sudoCheck(SudoGrid grid)
{
	int y, x;
	// clear invalid status.. check again
	for(y=0; y<9;++y)
	for(x=0;x<9;++x)
	{
		grid[y][x].state&=~INCORRECT;
	}
	// check duplicates in rows
	for(y=0; y<9;++y)
	for(x=0; x<8;++x)
	{
		if(grid[y][x].value!=0)
		{
			int x2;
			for(x2=x+1;x2<9;++x2)
			{
				if(grid[y][x].value==grid[y][x2].value)
				{
					grid[y][x ].state|=INCORRECT;
					grid[y][x2].state|=INCORRECT;
				}
			}
		}
	}

	// check duplicates in columns
	for(x=0; x<9;++x)
	for(y=0;y<8;++y)
	{
		if(grid[y][x].value!=0)
		{
			int y2;
			for(y2=y+1;y2<9;++y2)
			{
				if(grid[y][x].value==grid[y2][x].value)
				{
					grid[y ][x].state|=INCORRECT;
					grid[y2][x].state|=INCORRECT;
				}
			}
		}
	}

	for(y=0;y<9;y+=3)
	for(x=0;x<9;x+=3)
	{
		// check 3x3 block duplicates
		int x2,y2;
		for(y2=0; y2<3; ++y2)
		for(x2=0; x2<3; ++x2)
		{
			if(grid[y+y2][x+x2].value!=0)
			{
				int x3=x2;
				int y3=y2;
				for(;y3<3;y3++)
				{
					for(;x3<3;x3++)
					{
						if( y2!=y3 || x2!=x3)
						if(grid[y+y2][x+x2].value==grid[y+y3][x+x3].value)
						{
							grid[y+y2][x+x2].state|=INCORRECT;
							grid[y+y3][x+x3].state|=INCORRECT;
						}
					}
					x3 = 0;
				}
				
			}
		}
	}

}

void drawSudoGrid(SudoGrid grid)
{
#define SCREEN_WIDTH  640
#define SCREEN_HEIGHT 480
#define TILE_WIDTH  63
#define TILE_HEIGHT 46
#define INTER_SPACE 5
	int yPos = (SCREEN_HEIGHT-9*TILE_HEIGHT-2*INTER_SPACE);
	int y;
	for(y=0; y<9;++y)
	{
		int xPos = (SCREEN_WIDTH-9*TILE_WIDTH-2*INTER_SPACE);
		if(y==3||y==6)
		{
			yPos+=INTER_SPACE;
		}
		int x;
		for(x=0;x<9;++x)
		{
			if(x==3||x==6)
			{
				xPos+=INTER_SPACE;
			}
			// draw background tile first
			int tile;
// = (grid[y][x].state&GIVEN)?0x0C:(grid[y][x].state&INCORRECT)?0x0D:0x0A;
			if(grid[y][x].state&GIVEN)
			{
				tile = 0x0C;
			}
			else
			{
				tile = (grid[y][x].state&INCORRECT)?0x0D:0x0A;
				if(grid[y][x].state&UNCERTAIN)
					tile++;
			}
			drawTile(xPos, yPos, TILE_WIDTH, TILE_HEIGHT, tile, 0);
			if(grid[y][x].value!=0)
			{
				drawTile(xPos, yPos, TILE_WIDTH, TILE_HEIGHT, grid[y][x].value, 0);
			}
			xPos+=TILE_WIDTH;
		}
		yPos+=TILE_HEIGHT;
	}
}

void drawSudoCursor(int x, int y)
{
	int yPos = (SCREEN_HEIGHT-9*TILE_HEIGHT-2*INTER_SPACE);
	int xPos = (SCREEN_WIDTH-9*TILE_WIDTH-2*INTER_SPACE);
	xPos+=x*TILE_WIDTH;
	if(x>=3) xPos+=INTER_SPACE;
	if(x>=6) xPos+=INTER_SPACE;
	yPos+=y*TILE_HEIGHT;
	if(y>=3) yPos+=INTER_SPACE;
	if(y>=6) yPos+=INTER_SPACE;
	drawTile(xPos, yPos, TILE_WIDTH, TILE_HEIGHT, 0x0F, 0);	
}
 